#include <stdio.h>
#include <sys/time.h>
#include <iostream>
//#include "transcode.h"
#include "tools.h"

#include "include/common/exception.h"
#include "include/xpa/dom/dom.h"
#include "include/xpa/xmldoc/xmldoc.h"
#include "include/util/memorywriter.h"
#include "include/util/filewriter.h"
#include "include/util/stdoutwriter.h"

#define memsize MAXOUTSIZE

#define X(text) (text)

using namespace std;
INTEL_XML_NAMESPACE_USE
INTEL_XML_UTIL_NAMESPACE_USE
INTEL_XML_PARSE_DOM_NAMESPACE_USE
INTEL_XML_PARSE_XMLDOC_NAMESPACE_USE

char nsxsi[64]="http://www.w3.org/2001/XMLSchema-instance";
char nsenc[64]="http://www.w3.org/2001/12/soap-encoding";
char nssoap[64]="http://www.w3.org/2001/12/soap-envelope";
char nsopc[64]="http://opcfoundation.org/webservices/OPCDA/";

DOMImplementationFactory* domFactory;
XMLDocFactory* docFactory;

DOMImplementation* dom;
DOMWriter* writer;
MemoryWriter* output;

char 		*mem;

void initXML(struct TestData *td) {
    domFactory = DOMImplementationFactory::newInstance();
    dom = domFactory->getDOMImplementation();

    if (!td->memory_bench) {
	writer = dom->createDOMWriter();

	output = MemoryWriter::createMemoryWriter();//td->xml,td->xmllen);
	mem = new char[memsize+1];
    }
}

void releaseXML(struct TestData *td) {
    if (!td->memory_bench) {
	delete mem;
	delete output;

	dom->releaseDOMWriter(writer);
    }
    
    DOMImplementationFactory::releaseInstance(domFactory);
}

void parseXML(struct TestData *td, unsigned long iter) {
    const char id[5]="ID1\0";
    Element *pnode,*node,*node1,*node2;
    Document *doc;
//    XMLByte *mem;
    char str[16];
    int i;

    doc = dom->createDocument(X(nssoap),X("Envelope"),NULL);
    pnode = doc->getDocumentElement();
    pnode->setAttribute(X("xmlns"),X(nssoap));
    pnode->setAttribute(X("xmlns:xsi"),X(nsxsi));
    pnode->setAttribute(X("xmlns:enc"),X(nsenc));
    node=doc->createElementNS(X(nssoap),X("Body"));
    pnode->appendChild(node); pnode=node;

    node=doc->createElementNS(X(nsopc),X("WriteResponse"));
    pnode->appendChild(node);pnode=node;
    node=doc->createElementNS(X(nsopc),X("WriteResult"));
    node->setAttribute(X("RcvTime"),X("2002-04-29T10:16:26.6806250+02:00"));
    node->setAttribute(X("ReplyTime"),X("2002-04-29T10:16:26.7806250+02:00"));
    node->setAttribute(X("ClientRequestHandle"),X("WriteError"));
    node->setAttribute(X("RevisedLocaleID"),X("en"));
    node->setAttribute(X("ServerState"),X("running"));
    pnode->appendChild(node);
    node1=doc->createElementNS(X(nsopc),X("RItemList"));
    pnode->appendChild(node1);
    node=doc->createElementNS(X(nsopc),X("Errors"));
    node->setAttribute(X("ID"),X("E_UNKNOWNITEMID"));
    pnode->appendChild(node);
    node2=doc->createElementNS(X(nsopc),X("Text"));
    node->appendChild(node2);    
    node2->appendChild(doc->createTextNode(X("The item does not exist in the server address space.")));
    node=doc->createElementNS(X(nsopc),X("Errors"));
    node->setAttribute(X("ID"),X("S_CLAMP"));
    pnode->appendChild(node);
    node2=doc->createElementNS(X(nsopc),X("Text"));
    node->appendChild(node2);    
    node2->appendChild(doc->createTextNode(X("The value written was accepted but the output was clamped.")));

    pnode=node1;
    node=doc->createElementNS(X(nsopc),X("Items"));
    node->setAttribute(X("ItemPath"),X(""));
    node->setAttribute(X("ItemName"),X("WrongItemID1"));
    node->setAttribute(X("Timestamp"),X("0001-01-01T00:00:00.0000000+01:00"));
    node->setAttribute(X("ErrorID"),X("E_UNKNOWNITEMID"));
    pnode->appendChild(node);
    node1=doc->createElementNS(X(nsopc),X("Value"));
    node->appendChild(node1);
    node->setAttribute(X("xsi:nil"),X("true"));

    node=doc->createElementNS(X(nsopc),X("Items"));
    node->setAttribute(X("ItemPath"),X(""));
    node->setAttribute(X("ItemName"),X("WrongItemID2"));
    node->setAttribute(X("Timestamp"),X("0001-01-01T00:00:00.0000000+01:00"));
    node->setAttribute(X("ErrorID"),X("E_UNKNOWNITEMID"));
    pnode->appendChild(node);
    node1=doc->createElementNS(X(nsopc),X("Value"));
    node->appendChild(node1);
    node->setAttribute(X("xsi:nil"),X("true"));

    node=doc->createElementNS(X(nsopc),X("Items"));
    node->setAttribute(X("ItemPath"),X("/Reals"));
    node->setAttribute(X("ItemName"),X("Float1"));
    node->setAttribute(X("ValueType"),X("xsd:float"));
    node->setAttribute(X("Timestamp"),X("2002-04-29T11:47:18.1493750+02:00"));
    pnode->appendChild(node);
    node1=doc->createElementNS(X(nsopc),X("Value"));
    node->appendChild(node1);
    node->setAttribute(X("xsi:type"),X("xsd:float"));
    node1->appendChild(doc->createTextNode(X("10.0141414")));

    node=doc->createElementNS(X(nsopc),X("Items"));
    node->setAttribute(X("ItemPath"),X("/Reals"));
    node->setAttribute(X("ItemName"),X("Float2"));
    node->setAttribute(X("ValueType"),X("xsd:float"));
    node->setAttribute(X("Timestamp"),X("2002-04-29T11:47:18.1493750+02:00"));
    node->setAttribute(X("SuccessID"),X("S_CLAMP"));
    pnode->appendChild(node);
    node1=doc->createElementNS(X(nsopc),X("Value"));
    node->appendChild(node1);
    node->setAttribute(X("xsi:type"),X("xsd:float"));
    node1->appendChild(doc->createTextNode(X("1.07")));
    
    for (i=0;i<td->inc;i++) {
        node=doc->createElementNS(X(nsopc),X("Items"));
	node->setAttribute(X("ItemPath"),X("/Integer"));
        node->setAttribute(X("ItemName"),X("IntN"));
	node->setAttribute(X("ValueType"),X("xsd:int"));
        node->setAttribute(X("Timestamp"),X("2002-04-29T11:47:18.1493750+02:00"));
        node->setAttribute(X("SuccessID"),X("S_CLAMP"));
	pnode->appendChild(node);
        node1=doc->createElementNS(X(nsopc),X("Value"));
	node->appendChild(node1);
	node->setAttribute(X("xsi:type"),X("xsd:int"));
	sprintf(str,"%u",rand());
        node1->appendChild(doc->createTextNode(X(str)));
    }

    if (!td->memory_bench) {
	output->open(mem, memsize);
	writer->serializeDocument(output,doc);
    
	//if (iter==td->iterations) puts((char*)mem);

	output->close();
    }


    delete doc;    
}


int main(int argc, char *argv[]) {
    return Test(argc,argv);
}
