#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/time.h>
#include <stdio.h>
#include <string.h>
#include <sys/stat.h>
#include "asm-xml.h"

#include "tools.h"

#define chunkSize 16777216

AXClassContext  classContext;
AXElementClass* docClass;

void initXML(struct TestData *td) {
    struct stat st;
    char *schema;
    
    if (!strcmp(td->fn, "xmlgen")) {
	schema = ReadFile("../xml.files/generated.schema");
	if (!schema) {
	    printf("Schema file is not found\n");
	    exit(1);
	}
	
    }
    
    ax_initialize((void*)malloc, (void*)free);

    int res = ax_initializeClassParser(&classContext);
    if (res) {
	printf("Initialization failed: %i\n", res);
	exit(1);
    }
    
    docClass = ax_classFromString(schema+sizeof(unsigned long), &classContext);
    if( docClass == NULL ) {
	printf("Schema parse is failed\n");
	exit(1);
    }

    free(schema);

}



void releaseXML(struct TestData *td) {
    ax_releaseClassParser(&classContext);
}


void parseXML(struct TestData *td, unsigned long iter) {
    AXParseContext parseContext;
    AXElement *root;
    
    int res = ax_initializeParser(&parseContext, chunkSize);
    if( res != 0 ) {
	printf("Parser initialization is failed\n");
	exit(1);
    }

    root = ax_parse(&parseContext, td->xml, docClass, 1);
    if( root == NULL ) {
	printf("Parsing is failed\n");
	exit(1);
    }
    
    ax_releaseParser(&parseContext);
}

int main(int argc, char *argv[]) {
    return Test(argc,argv);
}
