using System;
using System.IO;
using System.Xml;

namespace XMLBench {
 abstract public class XMLBench {
    public void Bench(string[] args) {
	if (args.Length<2) {
	    Console.WriteLine("Usage:\n\tme <iterations> <xml file|xmlgen|opcgen|xmark> [size]");
	}

	int iterations = Convert.ToInt32(args[0]);
	
	bool mode;
	if ((args[1] == "xmlgen")||(args[1] == "opcgen")||(args[1] == "xmark")) {
	    mode = true;
	} else {
	    mode = false;
	}
	
	DateTime pre, post;
	TimeSpan ts = new TimeSpan(0);
	Disp d = new Disp();
	
	InitXML();
	
	FileStream xml;
	
	if (mode) xml = new FileStream("../xml.tmp/0.xml", FileMode.Open);
	else xml = new FileStream(args[1], FileMode.Open);
	
	ParseXML(xml, iterations, 0);
	
	xml.Close();
	
	for (int i = 0; i < iterations; i++) {
	    if (mode) xml = new FileStream("../xml.tmp/" + (i+1) + ".xml", FileMode.Open);
	    else xml = new FileStream(args[1], FileMode.Open);
	    
    	    pre = DateTime.Now;
	    ParseXML(xml, iterations, 0);
	    post = DateTime.Now;
	    d.disp_event((post - pre).TotalMilliseconds);
	    
	    xml.Close();
	    
	    ts += post - pre;

	}
	d.disp_post();
	
	ReleaseXML();

	if (args[1] == "opcgen") {
	    Console.WriteLine("Mono Time: " + ts.TotalMilliseconds + " ms");
	} else {
	    Console.WriteLine("Mono Time: " + ts.TotalMilliseconds/iterations + " ms" + " (" + (300*d.disp_d/d.disp_m) + "%)");
	}
    }
    virtual public void InitXML() {}
    virtual public void ReleaseXML() {}
    abstract public void ParseXML(Stream xml, int iters, int iter);
 }
}
