#include <stdio.h>
#include <sys/time.h>

#include "include/util/reader.h"
#include "include/util/filereader.h"
#include "include/util/memoryreader.h"
#include "include/common/defines.h"
#include "include/common/types.h"
#include "include/common/source.h"
#include "include/common/exception.h"
#include "include/xpa/dom/dom.h"

#include "tools.h"

INTEL_XML_NAMESPACE_USE
INTEL_XML_UTIL_NAMESPACE_USE
INTEL_XML_PARSE_DOM_NAMESPACE_USE

DOMImplementationFactory* domfactory;
DOMImplementation* domimpl;
DOMParser* parser;

void initXML(struct TestData *td) {
    domfactory = DOMImplementationFactory::newInstance();
    domimpl = domfactory->getDOMImplementation();
    parser = domimpl->createDOMParser();
}

void releaseXML(struct TestData *td) {
    domimpl->releaseDOMParser(parser);
    DOMImplementationFactory::releaseInstance(domfactory);
}

void parseXML(struct TestData *td, unsigned long iter) {
    const char id[5]="ID1\0";

    Document* doc = NULL;

    MemoryReader *buffer= MemoryReader::createMemoryReader(td->xml,td->xmllen);
    StreamSource *ss = new StreamSource(buffer, id);
    //buffer->setCopyBufToStream(false);

    doc = parser->parse(ss);

    delete ss;
    delete buffer;

    domimpl->releaseDocument(doc);
}


int main(int argc, char *argv[]) {
    return Test(argc,argv);
}
