/*  markup_stats.c - parabix demo program
    Copyright (c) 2007, Robert D. Cameron.
    Licensed to the public under the Open Software License 3.0.
    Licensed to International Characters, Inc., under the Academic
    Free License 3.0.

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <string>
#include <iostream>
using namespace std;

#define ON 1
#define OFF 2

#define TEMPLATED_SIMD_LIB
#define VALIDATION_MODE OFF

//#include "src/ilax.h"
#include "src/engine.h"

#include "tools.h"


/* Internals */
#include "src/xmlmodel.h"
#include "src/xml_error.h"
#include "src/bitplex.h"
#include "src/byteplex.h"
#include "src/xmldecl.h"
#include "src/bitlex.h"


#include "src/xmlmodel.c"
#include "src/xml_error.c"
#include "src/bitplex.c"
#include "src/byteplex.c"
#include "src/xmldecl.c"
#include "src/bitlex.c"
#include "src/engine.c"
#include "src/symtab.c"

/* Global declarations of parsing engine. */
Parser_Interface<UTF_8> * parser;


#ifdef LEAF_COUNTING
int at_start = 1;
int leaf_count = 0;
int interior_count = 0;
#endif

template<>
inline void Parser_Interface<UTF_8>::Comment_action(unsigned char * item, int lgth) {
}

template<>
inline void Parser_Interface<UTF_8>::CDATA_start_action(unsigned char * CDATA_ptr){
}

template<>
inline void Parser_Interface<UTF_8>::CDATA_end_action(unsigned char * CDATA_end_ptr) {
}

template<>
inline void Parser_Interface<UTF_8>::PI_action(unsigned char * item, int lgth) {
}

template<>
inline void Parser_Interface<UTF_8>::EmptyElement_action(unsigned char * item, int lgth) {
}

template<>
inline void Parser_Interface<UTF_8>::StartTag_action(unsigned char * item, int lgth) {
    return;
}

template<>
inline void Parser_Interface<UTF_8>::EndTag_action(unsigned char * item, int lgth) {
    return;
}

template<>
inline void Parser_Interface<UTF_8>::Error_action(unsigned char * item, int lgth) {
}

template<>
inline void Parser_Interface<UTF_8>::Text_action(unsigned char * item, int lgth, bool more) {
    return;
}

template<>
inline void Parser_Interface<UTF_8>::Reference_action(unsigned char * item, int lgth) {
}


template<>
inline void Parser_Interface<UTF_8>::ElementName_action(unsigned char * item, int lgth) {
}

template<>
inline void Parser_Interface<UTF_8>::PI_Target_action(unsigned char * item, int lgth) {
}

template<>
inline void Parser_Interface<UTF_8>::AttributeValue_action(unsigned char * name, int name_lgth, 
                                 unsigned char * val, int val_lgth) {
}

template<>
inline void Parser_Interface<UTF_8>::Namespace_action(unsigned char * name, int name_lgth,
                             unsigned char * URI, int URI_lgth) {
}


template<>
void Parser_Interface<UTF_8>::FinalizeBuffer_action() {
}


template<>
inline void Parser_Interface<UTF_8>::DocumentStart_action() {
}

template<>
inline void Parser_Interface<UTF_8>::DocumentEnd_action() {
}

template<>
inline void Parser_Interface<UTF_8>::Doctype_action(unsigned char * item, int lgth) {
}

template<>
inline void Parser_Interface<UTF_8>::PEReference_action(unsigned char * item, int lgth) {
}


template<>
inline void Parser_Interface<UTF_8>::ExtSubsetDecl_action(unsigned char * item, int lgth) {
}

template<>
inline void Parser_Interface<UTF_8>::Prolog_action(unsigned char * item, int lgth) {
}



void initXML(struct TestData *td) {
}

void releaseXML(struct TestData *td) {
}


void parseXML(struct TestData *td, unsigned long iter) {
/*
    int i = 0;
    Entity_Info * e;
    Model_Info * m;
    while ((td->xml[i] == ' ')||(td->xml[i] == '\r')||(td->xml[i] == '\n')||(td->xml[i] == '\t')) i++;
    if ((td->xml[i]=='<')&&(td->xml[i+1]=='?')) {
	for (i+=2;((td->xml[i]!='?')||(td->xml[i+1]!='>'))&&(td->xml[i]);i++);
	for (i+=2;(td->xml[i] == ' ')||(td->xml[i] == '\r')||(td->xml[i] == '\n')||(td->xml[i] == '\t');i++);
	if ((td->xml[i]=='<')&&(td->xml[i+1]=='?')) {
	    for (i+=2;((td->xml[i]!='?')||(td->xml[i+1]!='>'))&&(td->xml[i]);i++);
	    for (i+=2;(td->xml[i] == ' ')||(td->xml[i] == '\r')||(td->xml[i] == '\n')||(td->xml[i] == '\t');i++);
	}
    }
    e = new Entity_Info;
    m = new Model_Info;
    e->AnalyzeSignature((unsigned char*)"<?xml");
*/    

    parser = Parser_Interface<UTF_8>::ParserFactory("/tmp/parabix.test");//td->xml+i, td->xmllen-i, e, m);
    parser->Parse_Prolog();
    parser->Parse_DocumentContent();
//    parser->~Parser_Interface();
    delete parser;
/*
    delete m;
    delete e;
*/
}

int main(int argc, char *argv[]) {
    return Test(argc,argv);
}
